<%@page import="com.google.gson.Gson"%>
<%@ page  contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" %>
<%@page import="hr.genetics.models.Path"%>
<%@page import="java.util.Map"%>
<%@page import="hr.seminar.PathScanner"%>
<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<link rel="stylesheet" href="css/master.css" type="text/css" media="screen" charset="utf-8">
	<script type="text/javascript" src="lib/jquery.min.js"></script>
	<script type="text/javascript" src="lib/ocanvas.min.js"></script>
	
	<script type="text/javascript" src="js/ui.js"></script>

	<script type="text/javascript" src="js/Storage.js"></script>
	<script type="text/javascript" src="js/Line.js"></script>
	<script type="text/javascript" src="js/Point.js"></script>
	<script type="text/javascript" src="js/Checkpoint.js"></script>
	<script type="text/javascript" src="js/Path.js"></script>
	<script type="text/javascript" src="js/PathViewer.js"></script>
	<script type="text/javascript" src="js/PathBuilder.js"></script>
	<script type="text/javascript" src="js/Simulation.js"></script>
	
	<script type="text/javascript" charset="utf-8">
		window.onload = function() {
			
			function addNewPath(name, width, height) {
				
				var path = new Path(name);
				path.setWidth(width).setHeight(height);
				
				Storage.addPath(path);
				
			}
			
			function deletePath(id) {
				
				Storage.removePath(id);
				updatePaths();
				
			}
			
			$('#add_new_path').click(function(e){
				e.preventDefault();
				
				var name = $('#new_path_name').val();
				
				addNewPath(name, $('#path_width').val(), $('#path_height').val());
				updatePaths();

			});
			
			$('#delete_path').click(function(e){
				
				e.preventDefault();
				
				var $list = $('#paths_list');
				var pathId = $list.val();
				
				if (pathId != null) {
					deletePath(pathId);
				} else {
					console.log('Nothing selected!');
				}
				
			});
			
			$('#paths_list').change(function(){

				var pathId = $(this).val();
				var path = Storage.getPath(pathId);
								
				window.$PathViewer = new PathViewer(path, '#canvas_controls');
				window.$PathBuilder = new PathBuilder(path, $PathViewer);
				$PathViewer.updateView();				
				
			});
			
			$('#simulations').change(function(){				

				$.ajax({
					type: 'GET',
					url: "/genetics/Simulation",
					data: {
						"path": $(this).val()
					},
					success: function(data){
						window.simulation = new Simulation(data);
						var path = Storage.getPath(simulation.pathID);
						window.$PathViewer = new PathViewer(path, '#canvas_controls');
						window.$PathBuilder = new PathBuilder(path, $PathViewer);
						$PathViewer.updateView();	
					}
				});
								
			});
			
			$('#build_checkpoints').click(function(e){
				e.preventDefault();
				
				if (!$PathBuilder.buildingCheckpoints()) {
					$PathBuilder.startBuildingCheckpoints();
					$(this).html("Stop building checkpoints!");
				} else {
					$PathBuilder.stopBuildingCheckpoints();
					$(this).html("Build checkpoints!");
				}
			});
			
			$('#build_startline').click(function(e){
				e.preventDefault();
				
				$PathBuilder.startBuildingStartLine();
			});
			
			$('#save_path').click(function(e){
				
				e.preventDefault();
				$PathBuilder.path.update();				
				
			});
			
			$('#storage_export').click(function(e){
				
				$('.storage_export').slideDown();
				$('.storage_export textarea').html( Storage.getExportJSON() );
				
			});
			
			$('#storage_import').click(function(e){
				
				$('.storage_import').slideDown();
				$('.storage_import button').click(function(e){
					Storage.importFromJSON( $('.storage_import textarea').val() );
				});
				
			});
			
			$('#simulation_start').click(function(e){
				
				window.simulationIterator = simulation.getIterator();
				
				var startPosition = simulationIterator.next();
				var ocanvas = $PathViewer.getCanvas();
				var car = ocanvas.display.image({
					x: startPosition.getX()-10,
					y: startPosition.getY()-15,
					origin: { x: "center", y: "center" },
					image: "img/car.png",
					rotation: startPosition.getAngle(),
				});
				
				ocanvas.addChild(car);
				
				window.animationClock = 0;
				ocanvas.setLoop(function () {
					if (simulationIterator.hasNext()) {
						var currentPosition = simulationIterator.next();
						car.x = currentPosition.getX();
						car.y = currentPosition.getY();
						car.rotation = currentPosition.getAngle();
					} else {
						ocanvas.timeline.stop();
						ocanvas.removeChild(car);
						car = null;
					}
					animationClock++;
					if (animationClock % 30 == 0 || !simulationIterator.hasNext()) {
						var carShadow = car.clone();
						carShadow.opacity = 0.6;
						ocanvas.addChild(carShadow);
					}
					simulationIterator.next();
				}).start();/**/
				
			});
			
			$('.toggle').click(function(ev){
				
				ev.preventDefault();
				
				$($(this).attr('href')).toggle();
				
			});
						
			updatePaths();
			updateSimulations();
			$("#paths_list")[0].selectedIndex = 0;
			$("#paths_list").change();
			
			var calculating = false;
			$('#calculation_start').click(function(ev) {
				
				ev.preventDefault();
				
				var updateStatusID = window.setInterval(updateStatus, 3000);
				var pathID = $('#paths_list').val();
				
				if (calculating == true)
					return;
				
				calculating = true;
				$.ajax({
					type: 'POST',
					url: "/genetics/Calculation",
					data: {
						action: "start",
						pathID: pathID
					},
					success: function(data){
						calculating = false;
						updateStatus();
						updateSimulations();
						window.clearInterval(updateStatusID);
					}
				});
				updateStatus();
				
			});
			
			/** Dropbox **/
			/*var dropbox = document.getElementById("dropbox")

		 	dragOver = dragExit = dragEnter = function(evt) {
	
				evt.stopPropagation();
				evt.preventDefault();

			}

			drop = function(evt) {

				evt.stopPropagation();
				evt.preventDefault();
	
				var files = evt.dataTransfer.files;
	
				for ( var i = 0; i < files.length; i++ ) {
					importSimulationFromFile(files[i]);
				}

			}
		
			// init event handlers
			dropbox.addEventListener("dragenter", dragEnter, false);
			dropbox.addEventListener("dragexit", dragExit, false);
			dropbox.addEventListener("dragover", dragOver, false);
			dropbox.addEventListener("drop", drop, false);
			
			function importSimulationFromFile(file) {
				
				if ( !window.FileReader ) {
					console.log('FileReader!');
					return false;
				}	

				var reader = new FileReader();
				
				reader.onloadend = (function() {
					return function(e) {
						
						window.simulation = new Simulation(fileContent);
					}
				})(file);
				
				reader.readAsText(file);
				
			}/**/
						
		}
	</script>
	<title>Path builder</title>
</head>
<body>
	
	<header>
		<div class="wrapper">
			<h1 id="path_builder">Seminar</h1>
			<p class="date">Last update: <span>May, 2012</span></p>
		</div>
	</header>
	
	
	<div id="content">
		
		<div id="menu">
			
			<div class="wrapper">
				
				<a class="toggle" href="#build">Building</a>
				<form id="build" action="add_new_path" method="get" accept-charset="utf-8">

					<button id="delete_path">Delete path</button>	

					<fieldset id="adding_new_path">
						<legend>Adding new path</legend>

						<label for="new_path_name">Path name</label>
						<input type="text" name="new_path_name" placeholder="new path name" id="new_path_name">
						<label for="width">Width</label>
						<input type="number" name="width" value="600" id="path_width">
						<label for="height">Height</label>
						<input type="number" name="height" value="600" id="path_height">

						<input type="submit" value="Add" id="add_new_path">
					</fieldset>

					<a id="build_checkpoints" href="#checkpoints">Build checkpoints!</a>
					<a id="build_startline" href="#startline">Build startline!</a>
					<button id="save_path">Save path!</button>

				</form>
				
				<a class="toggle storage" href="#storage">Storage</a>
				<div id="storage">
				  	<a href="#" id="storage_export">Export Storage</a>
						<div class="storage_export">
						<textarea name="export" rows="8" cols="40"></textarea>
					</div>

					<a href="#" id="storage_import">Import Storage</a>
					<div class="storage_import">
						<textarea name="import" rows="8" cols="40"></textarea>
						<button>Import</button>
					</div>
				</div>
				
			</div>
			
		</div>
		
		<div class="wrapper">
			
			<div id="paths">
				<h2>Paths</h2>

				<select id="paths_list" size="10">
				</select>
			</div>
					
			<div id="path_preview">
				
				<div id="canvas_controls">
					<canvas id="path">
				</div>
				
				<button id="calculation_start">Calculate!</button>
				<button id="simulation_start">Simulate!</button>
			</div>
			
			<div id="right_column">
				
				<section>
					<h2>Status</h2>
					<div id="messages">
					</div>
				</section>
				
				<section>
					<h2>Simulations</h2>
					<select id="simulations" size="10">
					</select>
				</section>
				
			</div>
		
		</div>
		
		
	</div>
	
	<div id="simulation_controls">
		<div id="dropbox"></div>
		<!--<textarea name="simulation_params" id="simulation_params" rows="8" cols="40"></textarea>-->
		<br>
	</div>
	
	<script>
	
	(function( window, undefined ) {

		window.sharedPaths = <%
		
			Map<Integer, Path> paths = Path.getPaths();
			Gson gson = new Gson();
			out.write(gson.toJson(paths.values()));
		
		%>;
				
		window.Storage.importFromJSON();
				
	})(window);
	
	</script>
	
</body>
</html>